#ifndef _blackbox_llist_hh
#define _blackbox_llist_hh

// forward declarations
class llist_node;
class llist;


typedef struct __llist_node {
  __llist_node *next;
  void *data;
} __llist_node;


class __llist {
protected:
  __llist(void * = 0);
  ~__llist(void);

  const int count(void) const { return elements; }
  const int empty(void) const { return (elements == 0); }

  void *at(int);
  const int insert(void *);
  const int remove(void *);
  const int remove(const int);
  const int append(void *);
  void outputlist(void);

private:
  int elements;
  __llist_node *first, *last;
};


template <class Z>
class llist : __llist {
public:
  llist(Z *d = 0) : __llist(d)
    { }
  ~llist(void)
    { }

  const int count(void) const { return __llist::count(); }
  const int empty(void) const { return __llist::empty(); }

  Z *at(int index) { return (Z *) __llist::at(index); }
  const int insert(Z *d) { return __llist::insert((void *) d); }
  const int remove(Z *d) { return __llist::remove((void *) d); }
  const int remove(const int i) { return __llist::remove(i); }
  const int append(Z *d) { return __llist::append((void *) d); }
  void outputlist(void) { __llist::outputlist(); }
};


#endif
